﻿using Infragistics;
using Infragistics.Controls.Charts;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDataChartBubbleSeriesTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            
        }

        Series ChartBubbleSeries;
        public void Customize()

        {

            NumericXAxis numericXAxis = new NumericXAxis { Interval = 10, MinimumValue = 0, MaximumValue = 100 };

            NumericYAxis numericYAxis = new NumericYAxis { Interval = 10, MinimumValue = 0, MaximumValue = 100 };

            this.Chart.Axes.Add(numericXAxis);

            this.Chart.Axes.Add(numericYAxis);

            var sizeScale = new SizeScale {IsLogarithmic = false, MinimumValue = 10, MaximumValue = 90};

            var brushCollection = new BrushCollection
            {
                new SolidColorBrush(Color.FromArgb(255, 251, 20, 32)),
                new SolidColorBrush(Color.FromArgb(0xFF, 0x08, 0xC3, 0xFE)),
                new SolidColorBrush(Color.FromArgb(0xFF, 0x08, 0xA5, 0xFE)),
                new SolidColorBrush(Color.FromArgb(0xFF, 0x08, 0x6A, 0xFE)),
                new SolidColorBrush(Color.FromArgb(0xFF, 0x08, 0x4C, 0xFE)),
                new SolidColorBrush(Color.FromArgb(0xCC, 0x80, 0x8C, 0xDD)),
                new SolidColorBrush(Color.FromArgb(0xAA, 0x99, 0xC, 0xD))
            };

            var brushScale = new CustomPaletteBrushScale
            {
                Brushes = brushCollection,
                BrushSelectionMode = BrushSelectionMode.Select
            };

            ChartBubbleSeries = new BubbleSeries
            {
                RadiusMemberPath = "Radius",
                RadiusScale = sizeScale,
                FillScale = brushScale,
                XAxis = numericXAxis,
                YAxis = numericYAxis,
                XMemberPath = "X",
                YMemberPath = "Y",
                StartCap = PenLineCap.Round,
                ShadowBlur = 2.5,
                LineJoin =PenLineJoin.Bevel,
                ItemsSource = SetRandomSource()
            };

            //ChartBubbleSeries.TrendLineType = TrendLineType.LinearFit;

            ChartBubbleSeries.GetActualMarkerOutlineBrush();

            Chart.Series.Add(ChartBubbleSeries);

        }


        int _maxValueCount = 100;
        private IEnumerable<Point> SetRandomSource()
        {

            var points = new Point[_maxValueCount];

            double num = 99;

            double xNum = 25;

            for (int count = 0; count < _maxValueCount; count++)
            {

                if (count % 5 == 4)
                {

                    xNum += 0.001;

                    points[count] = new Point(xNum % 7, 50 + (count % 10) - 0.001);

                }

                else if (count % 5 == 3)
                {

                    points[count] = new Point(90, 80);

                }

                else if (count % 3 == 2)
                {

                    num -= 0.099;

                    points[count] = new Point(num % 25, count % 70);

                }

                else if (count % 2 == 1)
                {

                    //num += 5.099;

                    points[count] = new Point(xNum, 90);

                    //points[count] = new Point(80*Math.Log10(num), 190);

                }

                else
                {

                    num += 1 * (-1);

                    points[count] = new Point(Math.Abs(89 * Math.Sin(90 + num)), (num + count) % 21);

                }

            }

            return points;
        }

        private void Chart_Loaded(object sender, RoutedEventArgs e)
        {
            Customize();
        }
    }
}
